## libsepol 1.2

=== src/Makefile ===
# Installation directories.
PREFIX ?= $(DESTDIR)/usr
LIBDIR ?= $(PREFIX)/lib
SHLIBDIR ?= $(DESTDIR)/lib

LIBVERSION = 1

# Set to y for MLS
MLS=n

ifeq ($(MLS),y)
OPTIONS = -DCONFIG_SECURITY_SELINUX_MLS
else
OPTIONS =
endif

LIBA=libsepol.a 
TARGET=libsepol.so
LIBSO=$(TARGET).$(LIBVERSION)
OBJS= $(patsubst %.c,%.o,$(wildcard *.c))
LOBJS= $(patsubst %.c,%.lo,$(wildcard *.c))
CFLAGS = -Wall $(OPTIONS)
override CFLAGS += -I. -I../include

all: $(LIBA) $(LIBSO)

$(LIBA):  $(OBJS)
	$(AR) rcs $@ $^
	ranlib $@

$(LIBSO): $(LOBJS)
	$(CC) $(LDFLAGS) -shared -o $@ $^ -Wl,-soname,$(LIBSO),--version-script=libsepol.map
	ln -sf $@ $(TARGET) 

%.o:  %.c 
	$(CC) $(CFLAGS) -c -o $@ $<

%.lo:  %.c
	$(CC) $(CFLAGS) -fPIC -c -o $@ $<

install: all
	test -d $(LIBDIR) || install -m 755 -d $(LIBDIR)
	install -m 644 $(LIBA) $(LIBDIR)
	test -d $(SHLIBDIR) || install -m 755 -d $(SHLIBDIR)
	install -m 755 $(LIBSO) $(SHLIBDIR)
	cd $(LIBDIR) && ln -sf ../../`basename $(SHLIBDIR)`/$(LIBSO) $(TARGET)

clean: 
	rm -f $(OBJS) $(LOBJS) $(LIBA) $(LIBSO) $(TARGET)

## libsepol 1.4

=== Makefile ===
all: 
	$(MAKE) -C src 
	$(MAKE) -C utils

install: 
	$(MAKE) -C include install
	$(MAKE) -C src install
	$(MAKE) -C utils install
	$(MAKE) -C man install

relabel:
	$(MAKE) -C src relabel

clean:
	$(MAKE) -C src clean
	$(MAKE) -C utils clean

=== include/Makefile ===
# Installation directories.
PREFIX ?= $(DESTDIR)/usr
INCDIR ?= $(PREFIX)/include/sepol

install:
	test -d $(INCDIR) || install -m 755 -d $(INCDIR)
	install -m 644 $(wildcard sepol/*.h) $(INCDIR)

=== src/Makefile ===
--- 
+++ 
@@ -5,22 +5,13 @@
 
 LIBVERSION = 1
 
-# Set to y for MLS
-MLS=n
-
-ifeq ($(MLS),y)
-OPTIONS = -DCONFIG_SECURITY_SELINUX_MLS
-else
-OPTIONS =
-endif
-
 LIBA=libsepol.a 
 TARGET=libsepol.so
 LIBSO=$(TARGET).$(LIBVERSION)
 OBJS= $(patsubst %.c,%.o,$(wildcard *.c))
 LOBJS= $(patsubst %.c,%.lo,$(wildcard *.c))
-CFLAGS = -Wall $(OPTIONS)
-override CFLAGS += -I. -I../include
+CFLAGS = -Wall
+override CFLAGS += -I. -I../include -D_GNU_SOURCE
 
 all: $(LIBA) $(LIBSO)
 
@@ -45,6 +36,9 @@
 	install -m 755 $(LIBSO) $(SHLIBDIR)
 	cd $(LIBDIR) && ln -sf ../../`basename $(SHLIBDIR)`/$(LIBSO) $(TARGET)
 
+relabel:
+	/sbin/restorecon $(SHLIBDIR)/$(LIBSO)
+
 clean: 
 	rm -f $(OBJS) $(LOBJS) $(LIBA) $(LIBSO) $(TARGET)

=== utils/Makefile ===
# Installation directories.
PREFIX ?= $(DESTDIR)/usr
BINDIR ?= $(PREFIX)/bin

CFLAGS = -Wall
override CFLAGS += -I../include
LDLIBS += -L../src -lsepol 

TARGETS=$(patsubst %.c,%,$(wildcard *.c))

all: $(TARGETS)

install: all
	-mkdir -p $(BINDIR)
	install -m 755 $(TARGETS) $(BINDIR)

clean:
	rm -f $(TARGETS) *.o 

relabel:

## libsepol 1.12

=== include/Makefile ===
--- 
+++ 
@@ -4,4 +4,6 @@
 
 install:
 	test -d $(INCDIR) || install -m 755 -d $(INCDIR)
+	test -d $(INCDIR)/policydb || install -m 755 -d $(INCDIR)/policydb
 	install -m 644 $(wildcard sepol/*.h) $(INCDIR)
+	install -m 644 $(wildcard sepol/policydb/*.h) $(INCDIR)/policydb

=== src/Makefile ===
--- 
+++ 
@@ -10,7 +10,7 @@
 LIBSO=$(TARGET).$(LIBVERSION)
 OBJS= $(patsubst %.c,%.o,$(wildcard *.c))
 LOBJS= $(patsubst %.c,%.lo,$(wildcard *.c))
-CFLAGS = -Wall
+CFLAGS ?= -Wall -W -Wundef -Wmissing-noreturn -Wmissing-format-attribute
 override CFLAGS += -I. -I../include -D_GNU_SOURCE
 
 all: $(LIBA) $(LIBSO)
@@ -20,14 +20,14 @@
 	ranlib $@
 
 $(LIBSO): $(LOBJS)
-	$(CC) $(LDFLAGS) -shared -o $@ $^ -Wl,-soname,$(LIBSO),--version-script=libsepol.map
+	$(CC) $(LDFLAGS) -shared -o $@ $^ -Wl,-soname,$(LIBSO),--version-script=libsepol.map,-z,defs
 	ln -sf $@ $(TARGET) 
 
 %.o:  %.c 
 	$(CC) $(CFLAGS) -c -o $@ $<
 
 %.lo:  %.c
-	$(CC) $(CFLAGS) -fPIC -c -o $@ $<
+	$(CC) $(CFLAGS) -fpic -DSHARED -c -o $@ $<
 
 install: all
 	test -d $(LIBDIR) || install -m 755 -d $(LIBDIR)
@@ -40,5 +40,5 @@
 	/sbin/restorecon $(SHLIBDIR)/$(LIBSO)
 
 clean: 
-	rm -f $(OBJS) $(LOBJS) $(LIBA) $(LIBSO) $(TARGET) 
+	-rm -f $(OBJS) $(LOBJS) $(LIBA) $(LIBSO) $(TARGET)

=== utils/Makefile ===
--- 
+++ 
@@ -2,7 +2,7 @@
 PREFIX ?= $(DESTDIR)/usr
 BINDIR ?= $(PREFIX)/bin
 
-CFLAGS = -Wall
+CFLAGS ?= -Wall
 override CFLAGS += -I../include
 LDLIBS += -L../src -lsepol 
 
@@ -15,7 +15,7 @@
 	install -m 755 $(TARGETS) $(BINDIR)
 
 clean:
-	rm -f $(TARGETS) *.o 
+	-rm -f $(TARGETS) *.o 
 
 relabel:

## libsepol 1.14

=== include/Makefile ===
--- 
+++ 
@@ -7,3 +7,6 @@
 	test -d $(INCDIR)/policydb || install -m 755 -d $(INCDIR)/policydb
 	install -m 644 $(wildcard sepol/*.h) $(INCDIR)
 	install -m 644 $(wildcard sepol/policydb/*.h) $(INCDIR)/policydb
+
+indent:
+	../../Lindent $(wildcard sepol/*.h)

=== src/Makefile ===
--- 
+++ 
@@ -24,7 +24,7 @@
 	ln -sf $@ $(TARGET) 
 
 %.o:  %.c 
-	$(CC) $(CFLAGS) -c -o $@ $<
+	$(CC) $(CFLAGS) -fpic -c -o $@ $<
 
 %.lo:  %.c
 	$(CC) $(CFLAGS) -fpic -DSHARED -c -o $@ $<
@@ -42,3 +42,6 @@
 clean: 
 	-rm -f $(OBJS) $(LOBJS) $(LIBA) $(LIBSO) $(TARGET) 
 
+indent:
+	../../Lindent $(wildcard *.[ch])
+

=== utils/Makefile ===
--- 
+++ 
@@ -17,5 +17,8 @@
 clean:
 	-rm -f $(TARGETS) *.o 
 
+indent:
+	../../Lindent $(wildcard *.[ch])
+
 relabel:

## libsepol 2.0.3

=== src/Makefile ===
--- 
+++ 
@@ -24,10 +24,10 @@
 	ln -sf $@ $(TARGET) 
 
 %.o:  %.c 
-	$(CC) $(CFLAGS) -fpic -c -o $@ $<
+	$(CC) $(CFLAGS) -fPIC -c -o $@ $<
 
 %.lo:  %.c
-	$(CC) $(CFLAGS) -fpic -DSHARED -c -o $@ $<
+	$(CC) $(CFLAGS) -fPIC -DSHARED -c -o $@ $<
 
 install: all
 	test -d $(LIBDIR) || install -m 755 -d $(LIBDIR)
@@ -43,5 +43,5 @@
 	-rm -f $(OBJS) $(LOBJS) $(LIBA) $(LIBSO) $(TARGET) 
 
 indent:
-	../../Lindent $(wildcard *.[ch])
+	../../scripts/Lindent $(wildcard *.[ch])

=== utils/Makefile ===
--- 
+++ 
@@ -18,7 +18,7 @@
 	-rm -f $(TARGETS) *.o 
 
 indent:
-	../../Lindent $(wildcard *.[ch])
+	../../scripts/Lindent $(wildcard *.[ch])
 
 relabel:

## libsepol 2.0.20

=== src/Makefile ===
--- 
+++ 
@@ -10,7 +10,7 @@
 LIBSO=$(TARGET).$(LIBVERSION)
 OBJS= $(patsubst %.c,%.o,$(wildcard *.c))
 LOBJS= $(patsubst %.c,%.lo,$(wildcard *.c))
-CFLAGS ?= -Wall -W -Wundef -Wmissing-noreturn -Wmissing-format-attribute
+CFLAGS ?= -Werror -Wall -W -Wundef -Wmissing-noreturn -Wmissing-format-attribute
 override CFLAGS += -I. -I../include -D_GNU_SOURCE
 
 all: $(LIBA) $(LIBSO)
@@ -20,7 +20,7 @@
 	ranlib $@
 
 $(LIBSO): $(LOBJS)
-	$(CC) $(LDFLAGS) -shared -o $@ $^ -Wl,-soname,$(LIBSO),--version-script=libsepol.map,-z,defs
+	$(CC) $(CFLAGS) $(LDFLAGS) -shared -o $@ $^ -Wl,-soname,$(LIBSO),--version-script=libsepol.map,-z,defs
 	ln -sf $@ $(TARGET) 
 
 %.o:  %.c

=== tests/Makefile ===
M4 ?= m4
MKDIR ?= mkdir
EXE ?= libsepol-tests

CFLAGS += -g3 -gdwarf-2 -o0 -Wall -W -Wundef -Wmissing-noreturn -Wmissing-format-attribute -Wno-unused-parameter -Werror

# Statically link libsepol on the assumption that we are going to
# be testing internal functions.
LIBSEPOL := ../src/libsepol.a

# In order to load source policies we need to link in the checkpolicy/checkmodule parser and util code.
# This is less than ideal, but it makes the tests easier to maintain by allowing source policies
# to be loaded directly.
CHECKPOLICY := ../../checkpolicy/
CPPFLAGS += -I../include/ -I$(CHECKPOLICY)

# test program object files
objs := $(patsubst %.c,%.o,$(wildcard *.c))
parserobjs := $(CHECKPOLICY)queue.o $(CHECKPOLICY)y.tab.o $(CHECKPOLICY)parse_util.o $(CHECKPOLICY)lex.yy.o \
	$(CHECKPOLICY)module_compiler.o

# test policy pieces
m4support := $(wildcard policies/support/*.spt)
testsuites := $(wildcard policies/test-*)
policysrc := $(foreach path,$(testsuites),$(wildcard $(path)/*.conf))
stdpol := $(addsuffix .std,$(policysrc))
mlspol := $(addsuffix .mls,$(policysrc))
policies := $(stdpol) $(mlspol)

all: $(EXE) $(policies)
policies: $(policies)

$(EXE): $(objs) $(parserobjs) $(LIBSEPOL)
	$(CC) $(CFLAGS) $(CPPFLAGS) $(objs) $(parserobjs) -lfl -lcunit -lcurses $(LIBSEPOL) -o $@

%.conf.std: $(m4support) %.conf
	$(M4) $(M4PARAMS) $^ > $@

%.conf.mls: $(m4support) %.conf
	$(M4) $(M4PARAMS) -D enable_mls $^ > $@

clean: 
	rm -f $(objs) $(EXE)
	rm -f $(policies)

test: $(EXE) $(policies)
	./$(EXE)

.PHONY: all policies clean test

=== utils/Makefile ===
--- 
+++ 
@@ -2,7 +2,7 @@
 PREFIX ?= $(DESTDIR)/usr
 BINDIR ?= $(PREFIX)/bin
 
-CFLAGS ?= -Wall
+CFLAGS ?= -Wall -Werror
 override CFLAGS += -I../include
 LDLIBS += -L../src -lsepol

## libsepol 2.0.30-maemo1

=== src/Makefile ===
# Installation directories.
PREFIX ?= /usr
INCDIR ?= $(PREFIX)/include
LIBDIR ?= $(PREFIX)/lib
SHLIBDIR ?= $(DESTDIR)/lib

VERSION = $(shell cat ../VERSION)
LIBVERSION = 1

LIBA=libsepol.a 
TARGET=libsepol.so
LIBPC=libsepol.pc
LIBSO=$(TARGET).$(LIBVERSION)
OBJS= $(patsubst %.c,%.o,$(wildcard *.c))
LOBJS= $(patsubst %.c,%.lo,$(wildcard *.c))
CFLAGS ?= -Werror -Wall -W -Wundef -Wmissing-noreturn -Wmissing-format-attribute
override CFLAGS += -I. -I../include -D_GNU_SOURCE

all: $(LIBA) $(LIBSO) $(LIBPC)

$(LIBA):  $(OBJS)
	$(AR) rcs $@ $^
	ranlib $@

$(LIBSO): $(LOBJS)
	$(CC) $(CFLAGS) $(LDFLAGS) -shared -o $@ $^ -Wl,-soname,$(LIBSO),--version-script=libsepol.map,-z,defs
	ln -sf $@ $(TARGET) 

$(LIBPC): $(LIBPC).in
	sed -e 's/@VERSION@/$(VERSION)/; s:@prefix@:$(PREFIX):; s:@libdir@:$(LIBDIR):; s:@includedir@:$(INCDIR):' < $< > $@

%.o:  %.c 
	$(CC) $(CFLAGS) -fPIC -c -o $@ $<

%.lo:  %.c
	$(CC) $(CFLAGS) -fPIC -DSHARED -c -o $@ $<

install: all
	test -d $(DESTDIR)$(LIBDIR) || install -m 755 -d $(DESTDIR)$(LIBDIR)
	install -m 644 $(LIBA) $(DESTDIR)$(LIBDIR)
	test -d $(DESTDIR)$(LIBDIR)/pkgconfig || install -m 755 -d $(DESTDIR)$(LIBDIR)/pkgconfig
	install -m 644 $(LIBPC) $(DESTDIR)$(LIBDIR)/pkgconfig
	test -d $(SHLIBDIR) || install -m 755 -d $(SHLIBDIR)
	install -m 755 $(LIBSO) $(SHLIBDIR)
	cd $(DESTDIR)$(LIBDIR) && ln -sf ../../`basename $(SHLIBDIR)`/$(LIBSO) $(TARGET)

relabel:
	/sbin/restorecon $(SHLIBDIR)/$(LIBSO)

clean: 
	-rm -f $(OBJS) $(LOBJS) $(LIBA) $(LIBSO) $(TARGET) $(LIBPC)

indent:
	../../scripts/Lindent $(wildcard *.[ch])

=== debian/changelog ===
libsepol (2.0.30-maemo1) unstable; urgency=low

  * fix to compile for maemo

 -- Thomas Maass <inyourface@gmx.de>  Sat, 26 Jun 2008 20:27:00 +0200

libsepol (2.0.30-2) unstable; urgency=low

  * Added exec_prefix to libselinux.pc.
    Closes: #489724

 -- Russell Coker <russell@coker.com.au>  Sun, 13 Jul 2008 00:26:51 +1000

libsepol (2.0.30-1) unstable; urgency=low

  * Non-maintainer upload.
  * New version needed for latest policy.

 -- Russell Coker <russell@coker.com.au>  Fri, 11 Jul 2008 23:55:10 +1000

libsepol (2.0.25-2) unstable; urgency=low

  * Record the new location of the repository for this package (moved to a
    new git repository)
  * Move to the new, make -j friendly targets in debian/rules.

 -- Manoj Srivastava <srivasta@debian.org>  Sat, 31 May 2008 00:42:03 -0500

libsepol (2.0.25-1) unstable; urgency=low

  * New upstream release
    * Drop unused ->buffer field from struct policy_file.
    * Add policy_file_init() initalizer for struct policy_file and use it,
      from Todd C. Miller. 
    * Accept "Flask" as an alternate identifier string in kernel policies
      from Stephen Smalley. 
    * Add support for open_perms policy capability from Eric Paris.
  

 -- Manoj Srivastava <srivasta@debian.org>  Mon, 17 Mar 2008 13:29:44 -0500

libsepol (2.0.21-1) unstable; urgency=low

  * New upstream SVN HEAD.
    * Fix invalid memory allocation in policydb_index_others() from Jason Tang.
    * Port of Yuichi Nakamura's tune avtab to reduce memory usage patch
      from the kernel avtab to libsepol from Stephen Smalley. 
    * Add support for consuming avrule_blocks during expansion to reduce
      peak memory usage from Joshua Brindle.
    * Added support for policy capabilities from Todd Miller.
    * Prevent generation of policy.18 with MLS enabled from Todd Miller.
    * print module magic number in hex on mismatch, from Todd Miller.
    * clarify and reduce neverallow error reporting from Stephen Smalley.
    * Reject self aliasing at link time from Stephen Smalley.
    * Allow handle_unknown in base to be overridden by semanage.conf from
      Stephen Smalley. 
    * Fixed bug in require checking from Stephen Smalley.
    * Added user hierarchy checking from Todd Miller.       

 -- Manoj Srivastava <srivasta@debian.org>  Thu, 28 Feb 2008 08:30:19 -0600

libsepol (2.0.11-1) unstable; urgency=low

  * New upstream release.
    * Pass CFLAGS to CC even on link command, per Dennis Gilmore.
    * Merged support for the handle_unknown policydb flag from Eric Paris.
    * Moved next_entry and put_entry out-of-line to reduce code size from
      Ulrich Drepper. 
    * Fixed module_package_read_offsets bug introduced by the prior patch.
    * Eliminate unaligned accesses from policy reading code from Stephen
      Smalley.                                           Closes: Bug#439539
    * Allow dontaudits to be turned off during policy expansion from
      Joshua Brindle.
    * Fix sepol_context_clone to handle a NULL context correctly.
      This happens for e.g. semanage_fcontext_set_con(sh, fcontext, NULL)
      to set the file context entry to "<<none>>".
    * Merged error handling patch from Eamon Walsh.
  * The cross building support in Debian has been rewritten to stop
    overriding the CC  variable to $(MAKE) in order to correctly support
    those packages that build internal tools with the native compiler
    during the build. This means that other packages that assume that CC
    will be overridden by the cross-compiling build scripts now fail to
    build. The patch is simply to set CC to $(DEB_HOST_GNU_TYPE)-gcc only
    if a cross-build is detected. The solution was proposed by  Neil
    Williams, but has been modified to be more generally applicable.
                                                          Closes: Bug#448014
  * The API was added to in this release, which means we need a shlibs
    bump. The soname has not changed.

 -- Manoj Srivastava <srivasta@debian.org>  Wed, 06 Feb 2008 09:50:38 -0600

libsepol (2.0.3-1) unstable; urgency=low

  * New upstream bugfix SVN HEAD.
    + Merged fix from Karl to remap booleans at expand time to avoid holes
      in the symbol table. 
    + Merged add boolmap argument to expand_module_avrules() from Chris
      PeBenito. 

 -- Manoj Srivastava <srivasta@debian.org>  Sun,  6 May 2007 16:38:09 -0500

libsepol (2.0.1-1) unstable; urgency=low

  * New upstream release. This is the trunk, or development, version.
  * Merged patch to add errcodes.h to libsepol by Karl MacMillan.

 -- Manoj Srivastava <srivasta@debian.org>  Thu, 19 Apr 2007 17:17:39 -0500

libsepol (1.16.1-1) unstable; urgency=low

  * New upstream release
    * Merged libsepol segfault fix from Stephen Smalley for when
      sensitivities are required but not present in the base.
    * Updated version for stable branch.
    * Merged patch to compile wit -fPIC instead of -fpic from
      Manoj Srivastava to prevent hitting the global offest table
      limit. Patch changed to include libselinux and libsemanage in
      addition to libselinux.
    * Merged fix from Karl MacMillan for a segfault when linking
      non-MLS modules with users in them.
    * Merged fix for version comparison that was preventing range
      transition rules from being written for a version 5 base policy
      from Darrel Goeddel.
  * Added XS-VCS-Arch and XS-VCS-Browse to debian/control

 -- Manoj Srivastava <srivasta@debian.org>  Wed, 18 Apr 2007 19:34:35 -0500

libsepol (1.14-3) unstable; urgency=low

  * This fix is in reference to Bug#408278. In the postinst, we now use
    telinit u, instead of plain old init u, if telinit is available.
    Using init directly is bad form, according to sysvinit maintainer.
  * Make the dev package depend on the exact ${binary:Version}, not the
    ${Source-Version}, which should make this package friendlier to
    binNMUs. 

 -- Manoj Srivastava <srivasta@debian.org>  Mon, 26 Feb 2007 10:09:10 -0600



=== debian/control ===
Source: libsepol
VCS-Git: git://git.debian.org/~srivasta/debian/libsepol.git
VCS-Browser: http://git.debian.org/git/users/srivasta/debian/libsepol.git
Priority: optional
Section: libs
Maintainer: Thomas Maass <inyourface@gmx.de>
Standards-Version: 3.7.3.0
Build-Depends: file

Package: sepol-utils
Section: admin
Architecture: any
Depends: ${shlibs:Depends}
Conflicts: checkpolicy (<= 1.20)
Description: Security Enhanced Linux policy utility programs
 This package provides a utility for a Security-enhanced
 Linux system to rewrite existing mandatory access control policy with
 different boolean setting, generating a new policy. Security-enhanced
 Linux is a patch of the Linux kernel and a number of utilities with
 enhanced security functionality designed to add mandatory access
 controls to Linux. This package provides utility programs to get and
 set process and file security contexts and to obtain security policy
 decisions.


Package: libsepol1
Section: libs
Priority: required
Architecture: any
Depends: ${shlibs:Depends}
Description: Security Enhanced Linux policy library for changing policy binaries
 Security-enhanced Linux is a patch of the Linux kernel and a number
 of utilities with enhanced security functionality designed to add
 mandatory access controls to Linux.  The Security-enhanced Linux
 kernel contains new architectural components originally developed to
 improve the security of the Flask operating system. These
 architectural components provide general support for the enforcement
 of many kinds of mandatory access control policies, including those
 based on the concepts of Type Enforcement®, Role-based Access
 Control, and Multi-level Security.
 .
 libsepol provides an API for the manipulation of SELinux binary policies.
 It is used by checkpolicy (the policy compiler) and similar tools, as well
 as by programs like load_policy that need to perform specific transformations
 on binary policies such as customizing policy boolean settings.

Package: libsepol1-dev
Section: libdevel
Architecture: any
Provides:  libsepol-dev
Conflicts: libsepol-dev
Depends: ${shlibs:Depends},  libsepol1 (= ${binary:Version})
Description: Security Enhanced Linux policy library and development files
 libsepol allows programs to easily modify SELinux policy binaries.  This
 means changing the default values for booleans, or reading the policy for
 analysis.
 .
 This package contains the headers and archives used for linking it into your
 programs.

=== debian/watch ===
# format version number, currently 2; this line is compulsory!
version=2



http://www.nsa.gov/selinux/code/download-trunk.cfm ../archives/libsepol-(.*)\.tgz

## libsepol 2.0.37

=== src/Makefile ===
# Installation directories.
PREFIX ?= $(DESTDIR)/usr
LIBDIR ?= $(PREFIX)/lib
SHLIBDIR ?= $(DESTDIR)/lib

LIBVERSION = 1

LIBA=libsepol.a 
TARGET=libsepol.so
LIBSO=$(TARGET).$(LIBVERSION)
OBJS= $(patsubst %.c,%.o,$(wildcard *.c))
LOBJS= $(patsubst %.c,%.lo,$(wildcard *.c))
CFLAGS ?= -Werror -Wall -W -Wundef -Wshadow -Wmissing-noreturn -Wmissing-format-attribute
override CFLAGS += -I. -I../include -D_GNU_SOURCE

all: $(LIBA) $(LIBSO)

$(LIBA):  $(OBJS)
	$(AR) rcs $@ $^
	ranlib $@

$(LIBSO): $(LOBJS)
	$(CC) $(CFLAGS) $(LDFLAGS) -shared -o $@ $^ -Wl,-soname,$(LIBSO),--version-script=libsepol.map,-z,defs
	ln -sf $@ $(TARGET) 

%.o:  %.c 
	$(CC) $(CFLAGS) -fPIC -c -o $@ $<

%.lo:  %.c
	$(CC) $(CFLAGS) -fPIC -DSHARED -c -o $@ $<

install: all
	test -d $(LIBDIR) || install -m 755 -d $(LIBDIR)
	install -m 644 $(LIBA) $(LIBDIR)
	test -d $(SHLIBDIR) || install -m 755 -d $(SHLIBDIR)
	install -m 755 $(LIBSO) $(SHLIBDIR)
	cd $(LIBDIR) && ln -sf ../../`basename $(SHLIBDIR)`/$(LIBSO) $(TARGET)

relabel:
	/sbin/restorecon $(SHLIBDIR)/$(LIBSO)

clean: 
	-rm -f $(OBJS) $(LOBJS) $(LIBA) $(LIBSO) $(TARGET) 

indent:
	../../scripts/Lindent $(wildcard *.[ch])

## libsepol 2.0.41

=== src/Makefile ===
# Installation directories.
PREFIX ?= $(DESTDIR)/usr
INCLUDEDIR ?= $(PREFIX)/include
LIBDIR ?= $(PREFIX)/lib
SHLIBDIR ?= $(DESTDIR)/lib
LIBBASE=$(shell basename $(LIBDIR))

VERSION = $(shell cat ../VERSION)
LIBVERSION = 1

LIBA=libsepol.a 
TARGET=libsepol.so
LIBPC=libsepol.pc
LIBSO=$(TARGET).$(LIBVERSION)
OBJS= $(patsubst %.c,%.o,$(wildcard *.c))
LOBJS= $(patsubst %.c,%.lo,$(wildcard *.c))
CFLAGS ?= -Werror -Wall -W -Wundef -Wshadow -Wmissing-noreturn -Wmissing-format-attribute
override CFLAGS += -I. -I../include -D_GNU_SOURCE

all: $(LIBA) $(LIBSO) $(LIBPC)

$(LIBA):  $(OBJS)
	$(AR) rcs $@ $^
	ranlib $@

$(LIBSO): $(LOBJS)
	$(CC) $(CFLAGS) $(LDFLAGS) -shared -o $@ $^ -Wl,-soname,$(LIBSO),--version-script=libsepol.map,-z,defs
	ln -sf $@ $(TARGET) 

$(LIBPC): $(LIBPC).in
	sed -e 's/@VERSION@/$(VERSION)/; s:@prefix@:$(PREFIX):; s:@libdir@:$(LIBBASE):; s:@includedir@:$(INCLUDEDIR):' < $< > $@

%.o:  %.c 
	$(CC) $(CFLAGS) -fPIC -c -o $@ $<

%.lo:  %.c
	$(CC) $(CFLAGS) -fPIC -DSHARED -c -o $@ $<

install: all
	test -d $(LIBDIR) || install -m 755 -d $(LIBDIR)
	install -m 644 $(LIBA) $(LIBDIR)
	test -d $(SHLIBDIR) || install -m 755 -d $(SHLIBDIR)
	install -m 755 $(LIBSO) $(SHLIBDIR)
	test -d $(LIBDIR)/pkgconfig || install -m 755 -d $(LIBDIR)/pkgconfig
	install -m 644 $(LIBPC) $(LIBDIR)/pkgconfig
	cd $(LIBDIR) && ln -sf ../../`basename $(SHLIBDIR)`/$(LIBSO) $(TARGET)

relabel:
	/sbin/restorecon $(SHLIBDIR)/$(LIBSO)

clean: 
	-rm -f $(LIBPC) $(OBJS) $(LOBJS) $(LIBA) $(LIBSO) $(TARGET)

indent:
	../../scripts/Lindent $(wildcard *.[ch])

## libsepol 2.1.0-1.2

=== debian/changelog ===
libsepol (2.1.0-1.2) unstable; urgency=low

  * Non-maintainer upload since maintainer is busy
  * Build for multiarch, setting Pre-Depends multiarch-support in our shared
    lib package, closes: #638018
  * Always use -n with gzip, to avoid encoding timestamps in the gzip file;
    this ensures compressed docs and other files are identical across
    multiple builds, required for multiarch.

 -- Riku Voipio <riku.voipio@linaro.org>  Fri, 16 Dec 2011 17:43:47 +0200

libsepol (2.1.0-1.1) unstable; urgency=low

  * Made it NOT be a Debian native package.
  * Made myself the maintainer as Manoj has been busy for a while.

 -- Russell Coker <russell@coker.com.au>  Tue, 30 Aug 2011 14:41:02 +1000

libsepol (2.1.0-1) unstable; urgency=low

  * New Upstream version: new role transition and role attribute support.

 -- Russell Coker <russell@coker.com.au>  Mon, 29 Aug 2011 21:40:52 +1000

libsepol (2.0.42-1) unstable; urgency=low

  * New Upstream ver: Fix compliation under GCC 4.6 by Justin Mattock

 -- Russell Coker <russell@coker.com.au>  Wed, 05 Jan 2011 20:02:28 +1100

libsepol (2.0.41-1) unstable; urgency=low

  * Added myself to the uploaders.
  * This version is a trivial new upstream release, so it seems that we might
    as well just include it for Squeeze.

 -- Russell Coker <russell@coker.com.au>  Wed, 26 May 2010 14:54:26 +1000

libsepol (2.0.40-2) unstable; urgency=low

  * Fix typo found by lintian.
  * [25329c6]: [spelling fix]: cannnot -> cannot and suport -> support
    This was reported after a lintian check found this on any package
    linked with libsepol. Closes: #556390

 -- Manoj Srivastava <srivasta@debian.org>  Tue, 17 Nov 2009 10:29:54 -0600

libsepol (2.0.40-1) unstable; urgency=low

  * New upstream point release
    + Added pkgconfig file. This eliminates the last patch we were
      carrying against upstream.

 -- Manoj Srivastava <srivasta@debian.org>  Tue, 17 Nov 2009 09:53:02 -0600

libsepol (2.0.39-1) unstable; urgency=low

  * New upstream point release. Adds support for building Xen policies
    from Paul Nuzzi. 

 -- Manoj Srivastava <srivasta@debian.org>  Thu, 15 Oct 2009 22:53:54 -0500

libsepol (2.0.38-2) unstable; urgency=high

  * Handle the init=/bin/sh case in postinst    
    The previous tests did not check to see if the process running with
    process id 1 was actually /sbin/init, or if /dev/initctl was present to
    be talked to.
  * Note that checklibs fails with a spurious error on IA64.
  * Urgency high, since this is causing all kinds of failures in
    situations were init=/bin/sh, like qemubuilder.

 -- Manoj Srivastava <srivasta@debian.org>  Tue, 08 Sep 2009 11:52:21 -0500

libsepol (2.0.38-1) unstable; urgency=low

  * New upstream release
     Check last offset in the module package against the file size.
     Reported by Manoj Srivastava for bug filed by Max Kellermann.
  * Bug fix: "out of memory", thanks to Max Kellermann   (Closes: #543915).
  * Bug fix: "/etc/.initctl: ENOENT breaks debootstrap on kfreebsd",
    thanks to Philipp Kern. This package has been removed from all !linux
    architectures, and no longer builds on them.         (Closes: #543938).
  * First cut at providing symbols files.
  *  Check for extra libraries and shlib version numbers.  Unless there is
    a nocheck option in the deb build options variable, now we look to see
    if there are extra libraries we have linked to. Might need to back
    this out later, if this causes problems on the buildds.

 -- Manoj Srivastava <srivasta@debian.org>  Tue, 01 Sep 2009 16:58:24 -0500

libsepol (2.0.37-2) unstable; urgency=low

  * [f7ba986]: [libsepol]: common code update: Make sure the jobserver is
    no killed.
  * [b8570c3]: [libsepol] only run init -u when not in a chroot
    This fix was done 10 days ago, I just forgot to upload the new
    version; and then I was wondering how the bugs could possibly happen,
    since the code in front of me would prevent that.
    Bug fix: "postinst script fails in chroot environment", thanks to
    Ondřej Surý (Closes: #543347).
    Bug fix: "telinit doesn&#39;t work inside chroot", thanks to Sylvain
    Le Gall (Closes: #543344).

 -- Manoj Srivastava <srivasta@debian.org>  Mon, 24 Aug 2009 09:36:01 -0500

libsepol (2.0.37-1) unstable; urgency=low

  * New upstream release
    + Add method to check disable dontaudit flag from Christopher Pardy.

 -- Manoj Srivastava <srivasta@debian.org>  Thu, 13 Aug 2009 23:51:54 -0500

libsepol (2.0.36-1) unstable; urgency=low

  * New upstream release
    + Fix boolean state smashing from Joshua Brindle.
    + Fix alias field in module format, caused by boundary format change
      from Caleb Case.
    + Add bounds support from KaiGai Kohei.
    + Fix invalid aliases bug from Joshua Brindle.
    + Revert patch that removed expand_rule.

 -- Manoj Srivastava <srivasta@debian.org>  Wed, 29 Apr 2009 20:43:17 -0500

libsepol (2.0.32-1) unstable; urgency=low

  * New upstream release
    + Allow require then declare in the source policy from Joshua
      Brindle.
    + Fix mls_semantic_level_expand() to handle a user require w/o MLS
      information from Stephen Smalley.
  * Updated the watch and copyright files to reflect the new source
    location.

 -- Manoj Srivastava <srivasta@debian.org>  Mon, 09 Feb 2009 23:51:49 -0600

=== debian/control ===
--- 
+++ 
@@ -1,16 +1,18 @@
 Source: libsepol
 VCS-Git: git://git.debian.org/~srivasta/debian/libsepol.git
-VCS-Browser: http://git.debian.org/git/users/srivasta/debian/libsepol.git
+VCS-Browser: http://git.debian.org/git/?p=users/srivasta/debian/libsepol.git
 Priority: optional
 Section: libs
-Maintainer: Thomas Maass <inyourface@gmx.de>
-Standards-Version: 3.7.3.0
-Build-Depends: file
+Maintainer: Russell Coker <russell@coker.com.au>
+Uploaders: Manoj Srivastava <srivasta@debian.org>
+Standards-Version: 3.8.3.0
+Build-Depends: file, dpkg-dev (>= 1.16.0)
 
 Package: sepol-utils
 Section: admin
 Architecture: any
 Depends: ${shlibs:Depends}
+Multi-Arch: foreign
 Conflicts: checkpolicy (<= 1.20)
 Description: Security Enhanced Linux policy utility programs
  This package provides a utility for a Security-enhanced
@@ -24,11 +26,12 @@
 
 
 Package: libsepol1
-Section: libs
 Priority: required
 Architecture: any
 Depends: ${shlibs:Depends}
-Description: Security Enhanced Linux policy library for changing policy binaries
+Pre-Depends: multiarch-support
+Multi-Arch: same
+Description: SELinux library for manipulating binary security policies
  Security-enhanced Linux is a patch of the Linux kernel and a number
  of utilities with enhanced security functionality designed to add
  mandatory access controls to Linux.  The Security-enhanced Linux
@@ -47,11 +50,12 @@
 Package: libsepol1-dev
 Section: libdevel
 Architecture: any
-Provides:  libsepol-dev
+Provides: libsepol-dev
 Conflicts: libsepol-dev
 Depends: ${shlibs:Depends},  libsepol1 (= ${binary:Version})
-Description: Security Enhanced Linux policy library and development files
- libsepol allows programs to easily modify SELinux policy binaries.  This
+Multi-Arch: same
+Description: SELinux binary policy maniulation library and development files
+ libsepol allows programs to easily modify SELinux binary policies.  This
  means changing the default values for booleans, or reading the policy for
  analysis.
  .

=== debian/watch ===
# format version number, currently 2; this line is compulsory!
version=2



http://userspace.selinuxproject.org/releases/current/devel/libsepol-(.*)\.tar\.gz
#http://www.nsa.gov/selinux/code/download-trunk.cfm ../archives/libsepol-(.*)\.tgz

## libsepol 2.1.4

=== debian/changelog ===
libsepol (2.1.4-3ubuntu2) quantal; urgency=low

  * Specify CC so cross-builds work (LP: #1056975)

 -- Wookey <wookey@wookware.org>  Wed, 26 Sep 2012 16:34:20 +0100

libsepol (2.1.4-3ubuntu1) quantal; urgency=low

  * Touch /var/run/init.upgraded rather than calling 'telinit u' in the
    postinst, which causes a reboot when called in an Upstart chroot with
    busybox init.

 -- Colin Watson <cjwatson@ubuntu.com>  Tue, 18 Sep 2012 18:43:01 +0100

libsepol (2.1.4-3) unstable; urgency=low

  * Team upload.
  * debian/rules: Append CPPFLAGS hardening flags to CFLAGS (Closes: #665316)
  * debian/control: Re-add Conflicts/Provides for the libsepol1-dev package

 -- Laurent Bigonville <bigon@debian.org>  Sun, 01 Apr 2012 00:56:03 +0200

libsepol (2.1.4-2) unstable; urgency=low

  * Team upload.
  * Switch to dh sequence and debhelper 9
    - Enable hardened build flags (Closes: #656016)
  * Switch to dpkg-source 3.0 (quilt) format
  * debian/control:
    - Bump Standards-Version to 3.9.3 (no further changes)
    - Fix typo in Description (Closes: #639704)
    - Drop Conflict against checkpolicy (<= 1.20), it's long time gone
    - Drop Conflict/Provide against libsepol-dev, it's long time gone too
    - Drop Multi-Arch: same for -dev package
    - Drop Multi-Arch: foreign for sepol-utils package
    - Update Vcs-* fields
    - Add Homepage field
    - Make all binary packages arch:linux-any
    - Put under the Debian SELinux team maintenance
  * debian/patches/fix-pc-file.patch: Properly set multi-arch path in .pc file
    (Closes: #658440)
  * Add debian/gbp.conf file
  * debian/libsepol1.postinst: Unconditionally call telinit and ignore any
    errors (Closes: #652669, #663270)

 -- Laurent Bigonville <bigon@debian.org>  Tue, 20 Mar 2012 22:07:12 +0100

libsepol (2.1.4-1) unstable; urgency=low

  * New upstream version, changes to handling of tunables and moved some code
    from mcstrans to libsepol.
  * Added new symbols expand_module_avrules, sepol_get_preserve_tunables,
    and sepol_set_preserve_tunables.

 -- Russell Coker <russell@coker.com.au>  Mon, 20 Feb 2012 15:25:22 +1100

=== debian/control ===
--- 
+++ 
@@ -1,19 +1,19 @@
 Source: libsepol
-VCS-Git: git://git.debian.org/~srivasta/debian/libsepol.git
-VCS-Browser: http://git.debian.org/git/?p=users/srivasta/debian/libsepol.git
+VCS-Git: git://anonscm.debian.org/git/selinux/libsepol.git
+VCS-Browser: http://anonscm.debian.org/gitweb/?p=selinux/libsepol.git;a=summary
 Priority: optional
 Section: libs
-Maintainer: Russell Coker <russell@coker.com.au>
-Uploaders: Manoj Srivastava <srivasta@debian.org>
-Standards-Version: 3.8.3.0
-Build-Depends: file, dpkg-dev (>= 1.16.0)
+Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
+XSBC-Original-Maintainer: Debian SELinux maintainers <selinux-devel@lists.alioth.debian.org>
+Uploaders: Manoj Srivastava <srivasta@debian.org>, Russell Coker <russell@coker.com.au>
+Standards-Version: 3.9.3
+Build-Depends: debhelper (>= 9), dpkg-dev (>= 1.16.0), file
+Homepage: http://userspace.selinuxproject.org/
 
 Package: sepol-utils
 Section: admin
-Architecture: any
-Depends: ${shlibs:Depends}
-Multi-Arch: foreign
-Conflicts: checkpolicy (<= 1.20)
+Architecture: linux-any
+Depends: ${misc:Depends}, ${shlibs:Depends}
 Description: Security Enhanced Linux policy utility programs
  This package provides a utility for a Security-enhanced
  Linux system to rewrite existing mandatory access control policy with
@@ -24,11 +24,10 @@
  set process and file security contexts and to obtain security policy
  decisions.
 
-
 Package: libsepol1
 Priority: required
-Architecture: any
-Depends: ${shlibs:Depends}
+Architecture: linux-any
+Depends: ${misc:Depends}, ${shlibs:Depends}
 Pre-Depends: multiarch-support
 Multi-Arch: same
 Description: SELinux library for manipulating binary security policies
@@ -49,16 +48,14 @@
 
 Package: libsepol1-dev
 Section: libdevel
-Architecture: any
+Architecture: linux-any
+Depends: libsepol1 (= ${binary:Version}), ${misc:Depends}, ${shlibs:Depends}
 Provides: libsepol-dev
 Conflicts: libsepol-dev
-Depends: ${shlibs:Depends},  libsepol1 (= ${binary:Version})
-Multi-Arch: same
-Description: SELinux binary policy maniulation library and development files
+Description: SELinux binary policy manipulation library and development files
  libsepol allows programs to easily modify SELinux binary policies.  This
  means changing the default values for booleans, or reading the policy for
  analysis.
  .
  This package contains the headers and archives used for linking it into your
  programs.
-

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

DEB_HOST_MULTIARCH ?= $(shell dpkg-architecture -qDEB_HOST_MULTIARCH)
DESTDIR = $(CURDIR)/debian/tmp
export LIBDIR=$${DESTDIR}/usr/lib/${DEB_HOST_MULTIARCH}
export SHLIBDIR=$${DESTDIR}/lib/${DEB_HOST_MULTIARCH}
export LIBBASE=lib/${DEB_HOST_MULTIARCH}

# The build system doesn't use CPPFLAGS, pass them to CFLAGS to enable the
# missing (hardening) flags.
export DEB_CFLAGS_MAINT_APPEND = $(shell dpkg-buildflags --get CPPFLAGS)
export CC=$(shell dpkg-architecture -qDEB_HOST_GNU_TYPE)-gcc

%:
	dh $@

override_dh_auto_install:
	dh_auto_install
	rm -f $(DESTDIR)/usr/lib/$(DEB_HOST_MULTIARCH)/libsepol.so
	ln -s /lib/$(DEB_HOST_MULTIARCH)/libsepol.so.1 $(DESTDIR)/usr/lib/$(DEB_HOST_MULTIARCH)/libsepol.so

override_dh_auto_test:

## libsepol 2.1.9

=== debian/changelog ===
libsepol (2.1.9-2) unstable; urgency=low

  * Team upload.
  * debian/rules: Really fix cross-compilation (Closes: #688878)

 -- Laurent Bigonville <bigon@debian.org>  Mon, 20 May 2013 16:21:35 +0200

libsepol (2.1.9-1) unstable; urgency=low

  * Team upload.
  * New Upstream release
  * debian/rules: Automatically chose host gcc used when cross-compiling
    (Closes: #688878)

 -- Laurent Bigonville <bigon@debian.org>  Thu, 09 May 2013 15:12:53 +0200

libsepol (2.1.8-1) experimental; urgency=low

  * Team upload.
  * New Upstream release
  * debian/gbp.conf: Change default git-buildpackage build-directory and the
    debian-branch to "debian" instead of "upstream"
  * debian/watch: Fix watch file URL

 -- Laurent Bigonville <bigon@debian.org>  Tue, 25 Sep 2012 22:46:14 +0200

## libsepol 2.2

=== debian/changelog ===
libsepol (2.2-1) unstable; urgency=low

  * Team upload.
  * New upstream release
    - Drop debian/patches/fix-pc-file.patch: Merged upstream
  * debian/control: Bump Standards-Version to 3.9.4 (no further changes)
  * debian/control: Use canonical URL for VCS-Git field

 -- Laurent Bigonville <bigon@debian.org>  Fri, 01 Nov 2013 13:02:59 +0100

=== debian/rules ===
--- 
+++ 
@@ -13,7 +13,11 @@
 # The build system doesn't use CPPFLAGS, pass them to CFLAGS to enable the
 # missing (hardening) flags.
 export DEB_CFLAGS_MAINT_APPEND = $(shell dpkg-buildflags --get CPPFLAGS)
-export CC=$(shell dpkg-architecture -qDEB_HOST_GNU_TYPE)-gcc
+
+# for cross compilation
+ifneq ($(DEB_HOST_GNU_TYPE),$(DEB_BUILD_GNU_TYPE))
+export CC=$(DEB_HOST_GNU_TYPE)-gcc
+endif
 
 %:
 	dh $@

=== debian/watch ===
version=3

http://userspace.selinuxproject.org/releases/(\d+)/libsepol-(.*)\.tar\.gz

## libsepol 2.3

=== debian/changelog ===
libsepol (2.3-1) unstable; urgency=medium

  * Team upload.
  * New upstream release
  * debian/control: Mark -dev package as Multi-arch: same. (Closes: #738049)
  * debian/control: Bump Standards-Version to 3.9.5 (no further changes)

 -- Laurent Bigonville <bigon@debian.org>  Tue, 13 May 2014 17:35:24 +0200

=== debian/control ===
--- 
+++ 
@@ -1,12 +1,11 @@
 Source: libsepol
-VCS-Git: git://anonscm.debian.org/git/selinux/libsepol.git
+VCS-Git: git://anonscm.debian.org/selinux/libsepol.git
 VCS-Browser: http://anonscm.debian.org/gitweb/?p=selinux/libsepol.git;a=summary
 Priority: optional
 Section: libs
-Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
-XSBC-Original-Maintainer: Debian SELinux maintainers <selinux-devel@lists.alioth.debian.org>
+Maintainer: Debian SELinux maintainers <selinux-devel@lists.alioth.debian.org>
 Uploaders: Manoj Srivastava <srivasta@debian.org>, Russell Coker <russell@coker.com.au>
-Standards-Version: 3.9.3
+Standards-Version: 3.9.5
 Build-Depends: debhelper (>= 9), dpkg-dev (>= 1.16.0), file
 Homepage: http://userspace.selinuxproject.org/
 
@@ -52,6 +51,7 @@
 Depends: libsepol1 (= ${binary:Version}), ${misc:Depends}, ${shlibs:Depends}
 Provides: libsepol-dev
 Conflicts: libsepol-dev
+Multi-Arch: same
 Description: SELinux binary policy manipulation library and development files
  libsepol allows programs to easily modify SELinux binary policies.  This
  means changing the default values for booleans, or reading the policy for

## libsepol 2.4

=== cil/Makefile ===
PREFIX ?= $(DESTDIR)/usr
LIBDIR ?= $(PREFIX)/lib
SHLIBDIR ?= $(DESTDIR)/lib
INCLUDEDIR ?= $(PREFIX)/include
SRCDIR ?= ./src
TESTDIR ?= ./test
UNITDIR ?= $(TESTDIR)/unit
LIBCILDIR ?= $(SRCDIR)

LEX = flex

DEBUG = 0

SECILC = secilc

UNIT = unit_tests

SECILC_SRCS := secilc.c
SECILC_OBJS := $(patsubst %.c,%.o,$(SECILC_SRCS))

TEST_SRCS := $(wildcard $(UNITDIR)/*.c)
TEST_OBJS := $(patsubst %.c,%.o,$(TEST_SRCS))

LIBCIL_GENERATED := $(LIBCILDIR)/cil_lexer.c
LIBCIL_SRCS  := $(wildcard $(LIBCILDIR)/*.c) $(LIBCIL_GENERATED)
LIBCIL_OBJS := $(patsubst %.c,%.o,$(LIBCIL_SRCS))
LIBCIL_INCLUDES := $(wildcard $(LIBCILDIR)/*.h)

LIBCIL_STATIC := $(SRCDIR)/libcil.a

LIBSEPOL_STATIC = /usr/lib/libsepol.a

LIBS =
LDFLAGS =
COVCFLAGS = -fprofile-arcs -ftest-coverage -O0

CFLAGS ?= -Wall -Wshadow -Wextra -Wundef -Wmissing-format-attribute -Wcast-align -Wstrict-prototypes -Wpointer-arith -Wunused

ifeq ($(DEBUG),1)
	override CFLAGS += -g3 -O0 -gdwarf-2 -fno-strict-aliasing -DDEBUG
	override LDFLAGS += -g
else
	override CFLAGS += -O2
endif

override CFLAGS += -I./include -I$(INCLUDEDIR) -D_GNU_SOURCE -D_FILE_OFFSET_BITS=64

ARCH := $(patsubst i%86,i386,$(shell uname -m))
ifneq (,$(filter i386,$(ARCH)))
	TLSFLAGS += -mno-tls-direct-seg-refs
endif
ifneq (,$(filter x86_64,$(ARCH)))
	override LDFLAGS += -I/usr/lib64
	override LIBSEPOL_STATIC = /usr/lib64/libsepol.a
endif

all: $(SECILC)

%.o: %.c $(LIBCIL_INCLUDES)
	$(CC) $(CFLAGS) -c -o $@ $<

$(LIBCIL_STATIC): $(LIBCIL_OBJS)
	$(AR) rcs $@ $^
	ranlib $@

$(LIBCIL_GENERATED): $(LIBCILDIR)/cil_lexer.l
	$(LEX) -t $< > $@

$(UNIT): $(TEST_OBJS) $(LIBCIL_STATIC)
	$(CC) $(CFLAGS) -o $@ $^ $(LIBCIL_STATIC) $(LIBSEPOL_STATIC) $(LDFLAGS)

$(SECILC): $(SECILC_OBJS) $(LIBCIL_STATIC)
	$(CC) $(CFLAGS) -o $@ $^ $(LIBCIL_STATIC) $(LIBSEPOL_STATIC) $(LDFLAGS)

unit: $(SECILC) $(UNIT)

# Requires lcov 1.9+ (--ignore-errors)
coverage: CFLAGS += $(COVCFLAGS)
coverage: clean unit
	./unit_tests
	test -d cov || mkdir cov
	lcov --directory src --capture --output-file cov/app.info --ignore-errors source -b src
	lcov --remove cov/app.info '/usr/include/*' --remove cov/app.info 'sepol/*' --output-file cov/app.info
	genhtml -o ./cov/html ./cov/app.info

test: $(SECILC)
	./$(SECILC) test/policy.cil

clean:
	rm -f $(SECILC)
	rm -f $(LIBCIL_STATIC)
	rm -f $(TEST_OBJS) $(SECILC_OBJS)
	rm -rf cov src/*.gcda src/*.gcno *.gcda *.gcno
	rm -f $(LIBCIL_OBJS)

bare: clean
	rm -f $(LIBCIL_GENERATED)
	rm -f $(UNIT)
	rm -f policy.*
	rm -f file_contexts

.PHONY: all bare clean coverage test unit

=== include/Makefile ===
# Installation directories.
PREFIX ?= $(DESTDIR)/usr
INCDIR ?= $(PREFIX)/include/sepol
CILDIR ?= ../cil

all:

install: all
	test -d $(INCDIR) || install -m 755 -d $(INCDIR)
	test -d $(INCDIR)/policydb || install -m 755 -d $(INCDIR)/policydb
	test -d $(INCDIR)/cil || install -m 755 -d $(INCDIR)/cil
	install -m 644 $(wildcard sepol/*.h) $(INCDIR)
	install -m 644 $(wildcard sepol/policydb/*.h) $(INCDIR)/policydb
	install -m 644 $(wildcard $(CILDIR)/include/cil/*.h) $(INCDIR)/cil

indent:
	../../scripts/Lindent $(wildcard sepol/*.h)

=== src/Makefile ===
# Installation directories.
PREFIX ?= $(DESTDIR)/usr
INCLUDEDIR ?= $(PREFIX)/include
LIBDIR ?= $(PREFIX)/lib
SHLIBDIR ?= $(DESTDIR)/lib
RANLIB ?= ranlib
LIBBASE ?= $(shell basename $(LIBDIR))
CILDIR ?= ../cil

VERSION = $(shell cat ../VERSION)
LIBVERSION = 1

LEX = flex
CIL_GENERATED = $(CILDIR)/src/cil_lexer.c

LIBA=libsepol.a 
TARGET=libsepol.so
LIBPC=libsepol.pc
LIBMAP=libsepol.map
LIBSO=$(TARGET).$(LIBVERSION)
OBJS= $(patsubst %.c,%.o,$(wildcard *.c))
LOBJS= $(patsubst %.c,%.lo,$(wildcard *.c))
CFLAGS ?= -Werror -Wall -W -Wundef -Wshadow -Wmissing-format-attribute -O2

override CFLAGS += -I. -I../include -D_GNU_SOURCE

ifneq ($(DISABLE_CIL),y)
OBJS += $(sort $(patsubst %.c,%.o,$(wildcard $(CILDIR)/src/*.c) $(CIL_GENERATED)))
LOBJS += $(sort $(patsubst %.c,%.lo,$(wildcard $(CILDIR)/src/*.c) $(CIL_GENERATED)))
override CFLAGS += -I$(CILDIR)/include
endif


all: $(LIBA) $(LIBSO) $(LIBPC)


$(LIBA):  $(OBJS)
	$(AR) rcs $@ $^
	$(RANLIB) $@

$(LIBSO): $(LOBJS) $(LIBMAP)
	$(CC) $(CFLAGS) $(LDFLAGS) -shared -o $@ $(LOBJS) -Wl,-soname,$(LIBSO),--version-script=$(LIBMAP),-z,defs
	ln -sf $@ $(TARGET) 

$(LIBPC): $(LIBPC).in ../VERSION
	sed -e 's/@VERSION@/$(VERSION)/; s:@prefix@:$(PREFIX):; s:@libdir@:$(LIBBASE):; s:@includedir@:$(INCLUDEDIR):' < $< > $@

$(LIBMAP): $(LIBMAP).in
ifneq ($(DISABLE_CIL),y)
	cp $< $@
else
	sed -e '/^\s*cil_/d' < $< > $@
endif

ifneq ($(DISABLE_CIL),y)
$(CILDIR)/src/cil_lexer.c: $(CILDIR)/src/cil_lexer.l
	$(LEX) -t $< > $@
endif

%.o:  %.c 
	$(CC) $(CFLAGS) -fPIC -c -o $@ $<

%.lo:  %.c
	$(CC) $(CFLAGS) -fPIC -DSHARED -c -o $@ $<

install: all
	test -d $(LIBDIR) || install -m 755 -d $(LIBDIR)
	install -m 644 $(LIBA) $(LIBDIR)
	test -d $(SHLIBDIR) || install -m 755 -d $(SHLIBDIR)
	install -m 755 $(LIBSO) $(SHLIBDIR)
	test -d $(LIBDIR)/pkgconfig || install -m 755 -d $(LIBDIR)/pkgconfig
	install -m 644 $(LIBPC) $(LIBDIR)/pkgconfig
	ln -sf --relative $(SHLIBDIR)/$(LIBSO) $(LIBDIR)/$(TARGET)

relabel:
	/sbin/restorecon $(SHLIBDIR)/$(LIBSO)

clean: 
	-rm -f $(LIBPC) $(OBJS) $(LOBJS) $(LIBA) $(LIBSO) $(TARGET) $(CIL_GENERATED)

indent:
	../../scripts/Lindent $(wildcard *.[ch])

=== cil/docs/Makefile ===
HTMLDIR ?= ./html
PDFDIR ?= ./pdf
MAN8DIR ?= ./man8

# The CIL Reference Guide first part
CIL_REF_GUIDE = CIL_Reference_Guide.xml
# All the docbook files that make up the guide:
FILE_LIST ?= $(CIL_REF_GUIDE) $(wildcard cil*.xml)
# xmlto generates a *.proc file that can be removed.
PROC_FILE = CIL_Reference_Guide.proc

# The secilc man page:
MANPAGE = secilc.8.xml


# look for xmlto and dblatex packages
XMLTO = $(shell which xmlto 2> /dev/null | grep / | head -n1)
DBLATEX = $(shell which dblatex 2> /dev/null | grep / | head -n1)

# If no xmlto then exit as cannot proceed.
ifeq ($(XMLTO),)
$(error xmlto package not found - install package.)
endif

all: html pdf man

html: $(FILE_LIST)
	$(XMLTO) html $(CIL_REF_GUIDE)
	@mkdir -p $(HTMLDIR)
	@for m in *.html; do if [ -f $$m ]; then mv $$m $(HTMLDIR); fi; done
	@rm -f $(PROC_FILE)


pdf: $(FILE_LIST)
# Check if dblatex is available
ifeq ($(DBLATEX),)
	$(error dblatex package not found - install package for a pdf document.)
endif
	$(XMLTO) --with-dblatex pdf  $(CIL_REF_GUIDE)
	@mkdir -p $(PDFDIR)
	@for m in *.pdf; do if [ -f $$m ]; then mv $$m $(PDFDIR); fi; done
	@rm -f $(PROC_FILE)


man: $(MANPAGE)
	$(XMLTO) man $(MANPAGE)
	@mkdir -p $(MAN8DIR)
	@for m in *.8; do if [ -f $$m ]; then mv $$m $(MAN8DIR); fi; done
	@rm -f $(MANPAGE).proc

=== debian/changelog ===
libsepol (2.4-2) unstable; urgency=medium

  * Team upload.
  * Upload to unstable
  * debian/control: Use ${misc:Pre-Depends} instead of pre-depending directly
    against multiarch-support

 -- Laurent Bigonville <bigon@debian.org>  Wed, 18 Nov 2015 17:53:15 +0100

libsepol (2.4-1) experimental; urgency=medium

  * Team upload.
  * New upstream release
    - debian/control: Add flex to the build-dependency
    - debian/libsepol1.symbols: Adjust the .symbols file
  * debian/control: Bump Standards-Version to 3.9.6 (no further changes)
  * debian/watch: Update watch file URL

 -- Laurent Bigonville <bigon@debian.org>  Tue, 02 Jun 2015 18:53:02 +0200

libsepol (2.3-2) unstable; urgency=medium

  * Team upload.
  * Drop debian/libsepol1.postinst: Reloading systemd during an upgrade in an
    uncontroled way might endup with unwanted side effects (Closes: #753727)

 -- Laurent Bigonville <bigon@debian.org>  Sun, 31 Aug 2014 20:02:14 +0200

=== debian/control ===
--- 
+++ 
@@ -5,8 +5,8 @@
 Section: libs
 Maintainer: Debian SELinux maintainers <selinux-devel@lists.alioth.debian.org>
 Uploaders: Manoj Srivastava <srivasta@debian.org>, Russell Coker <russell@coker.com.au>
-Standards-Version: 3.9.5
-Build-Depends: debhelper (>= 9), dpkg-dev (>= 1.16.0), file
+Standards-Version: 3.9.6
+Build-Depends: debhelper (>= 9), dpkg-dev (>= 1.16.0), file, flex
 Homepage: http://userspace.selinuxproject.org/
 
 Package: sepol-utils
@@ -27,7 +27,7 @@
 Priority: required
 Architecture: linux-any
 Depends: ${misc:Depends}, ${shlibs:Depends}
-Pre-Depends: multiarch-support
+Pre-Depends: ${misc:Pre-Depends}
 Multi-Arch: same
 Description: SELinux library for manipulating binary security policies
  Security-enhanced Linux is a patch of the Linux kernel and a number

=== debian/watch ===
version=3

https://github.com/SELinuxProject/selinux/wiki/Releases (?:.*)/releases/(?:\d*)/libsepol-([\d\.]*)\.tar\.gz

## libsepol 2.5

=== debian/changelog ===
libsepol (2.5-1) unstable; urgency=medium

  * Team upload.
  * New upstream release
    - Adjust .symbols file. The symbols are now versioned
  * debian/gbp.conf: Sign tags by default
  * debian/control: Bump Standards-Version to 3.9.7 (no further changes)
  * debian/control: Fix Vcs-* URL's to please lintian (again)
  * debian/rules: Pass --list-missing to dh_install

 -- Laurent Bigonville <bigon@debian.org>  Sun, 24 Apr 2016 15:15:01 +0200

=== debian/control ===
--- 
+++ 
@@ -1,11 +1,11 @@
 Source: libsepol
-VCS-Git: git://anonscm.debian.org/selinux/libsepol.git
-VCS-Browser: http://anonscm.debian.org/gitweb/?p=selinux/libsepol.git;a=summary
+VCS-Git: https://anonscm.debian.org/git/selinux/libsepol.git
+VCS-Browser: https://anonscm.debian.org/gitweb/?p=selinux/libsepol.git;a=summary
 Priority: optional
 Section: libs
 Maintainer: Debian SELinux maintainers <selinux-devel@lists.alioth.debian.org>
 Uploaders: Manoj Srivastava <srivasta@debian.org>, Russell Coker <russell@coker.com.au>
-Standards-Version: 3.9.6
+Standards-Version: 3.9.7
 Build-Depends: debhelper (>= 9), dpkg-dev (>= 1.16.0), file, flex
 Homepage: http://userspace.selinuxproject.org/
